/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 184 by dpavlin, Tue Mar 16 20:42:38 2010 UTC revision 272 by dpavlin, Fri Sep 9 18:27:11 2011 UTC
# Line 16  Line 16 
16  #  #
17  # based on Tony Risinger post to lxc-users mailing list  # based on Tony Risinger post to lxc-users mailing list
18  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19    #
20    # Install with:
21    # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22    # update-rc.d lxc-watchdog defaults
23    
24    
25  which inotifywait >/dev/null || apt-get install inotify-tools  which inotifywait >/dev/null || apt-get install inotify-tools
# Line 33  lxc_exists() { Line 37  lxc_exists() {
37    
38    
39  lxc_rootfs() {  lxc_rootfs() {
40          grep lxc.rootfs "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'          grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41    }
42    
43    lxc_hostname() {
44            inside=`cat $(lxc_rootfs $1)/etc/hostname`
45            config=`grep lxc.utsname /var/lib/lxc/$name/config | cut -d= -f2`
46            echo "$config [$inside]";
47  }  }
48    
49    lxc_ip() {
50            ( grep lxc.network.ipv4 /var/lib/lxc/$name/config | grep -v '^#' | cut -d= -f2 || \
51            grep address $(lxc_rootfs $name)/etc/network/interfaces | grep -v '^#' | sed 's/.*address //' ) | \
52            head -1 | \
53            sed -e 's/ *//g' -e 's/\/.*$//'
54    }
55    
56  lxc_status() {  lxc_status() {
57          lxc-ls -1 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do          ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | while read name ; do
58                  on_boot="       "                  status=`lxc-info -n $name 2>/dev/null | grep state: | cut -d: -f2`     # 0.7.5
59                  test -s /var/lib/lxc/$name/on_boot && on_boot="on_boot"                  test -z "$status" && status=`lxc-info -n $name | sed -e 's/^.* is //'` # 0.7.2
60                  echo "$name $status $on_boot $(lxc_rootfs $name)"                  boot="-"
61          done                  test -s /var/lib/lxc/$name/on_boot && boot="boot"
62                    echo "$name $status $boot $(lxc_rootfs $name) $(lxc_ip $name) $(lxc_hostname $name)"
63            done ) | column -t
64  }  }
65    
66    
# Line 50  cleanup_init_scripts() { Line 68  cleanup_init_scripts() {
68          rootfs=$(lxc_rootfs $1)          rootfs=$(lxc_rootfs $1)
69    
70          ls \          ls \
71                    $rootfs/etc/rc?.d/*checkroot* \
72                  $rootfs/etc/rc?.d/*umountfs \                  $rootfs/etc/rc?.d/*umountfs \
73                  $rootfs/etc/rc?.d/*umountroot \                  $rootfs/etc/rc?.d/*umountroot \
74                  $rootfs/etc/rc?.d/*hwclock* \                  $rootfs/etc/rc?.d/*hwclock* \
75                    $rootfs/etc/rc?.d/*udev* \
76                    $rootfs/etc/rc?.d/*checkfs* \
77          2>/dev/null | xargs -i rm -v {}          2>/dev/null | xargs -i rm -v {}
78    
79            echo $1 > $rootfs/etc/hostname
80            grep $1 $rootfs/etc/hosts || echo "$(lxc_ip $1) $1" >> $rootfs/etc/hosts
81  }  }
82    
83    
# Line 64  setup_inittab() { Line 88  setup_inittab() {
88    
89          # let container respond to kill -SIGPWR          # let container respond to kill -SIGPWR
90          inittab=$rootfs/etc/inittab          inittab=$rootfs/etc/inittab
91          if ! grep "$add" ${inittab} >/dev/null ; then          if test -e $inittab && ! grep "$add" ${inittab} >/dev/null ; then
92                  grep -v "$remove" ${inittab} > ${inittab}.new                  grep -v "$remove" ${inittab} > ${inittab}.new
93                  echo $add >> ${inittab}.new                  echo $add >> ${inittab}.new
94                  mv ${inittab}.new ${inittab}                  mv ${inittab}.new ${inittab}
# Line 73  setup_inittab() { Line 97  setup_inittab() {
97  }  }
98    
99    
100    lxc_log() {
101            echo `date +%Y-%m-%dT%H:%M:%S` $*
102    }
103    
104    
105  lxc_kill() {  lxc_kill() {
106          name=$1          name=$1
107          sig=$2          sig=$2
# Line 82  lxc_kill() { Line 111  lxc_kill() {
111                  lxc-info -n $name                  lxc-info -n $name
112                  exit 1                  exit 1
113          fi          fi
114          echo "$name kill $sig $init_pid"          lxc_log "$name kill $sig $init_pid"
115          /bin/kill $sig $init_pid          /bin/kill $sig $init_pid
116  }  }
117    
118  lxc_stop() {  lxc_stop() {
119            lxc_log "$name stop"
120          lxc_kill $name -SIGPWR          lxc_kill $name -SIGPWR
121          lxc-wait -n $name -s STOPPED          lxc-wait -n $name -s STOPPED
122            lxc_log "$name stoped"
123  #       rm -f /var/lib/lxc/${name}/on_boot  #       rm -f /var/lib/lxc/${name}/on_boot
124  }  }
125    
126    
127  lxc_start() {  lxc_start() {
128          name=$1          name=$1
129            rootfs=$(lxc_rootfs $1)
130    
131            if [ ! -e $rootfs ] ; then
132                    echo "ERROR $name rootfs $rootfs not found"
133                    return
134            fi
135    
136          if ! lxc-info -n $name | grep RUNNING ; then          if ! lxc-info -n $name | grep RUNNING ; then
137                  echo "$name start"                  lxc_log "$name start"
138                    dev=`df -P $rootfs | tail -1 | cut -d" " -f1`
139                    mount $dev -o remount,rw # fix debian upgrade which remounts dir ro
140                  lxc-start -n $name -o /tmp/${name}.log -d                  lxc-start -n $name -o /tmp/${name}.log -d
141                  lxc-wait  -n $name -s RUNNING                  lxc-wait  -n $name -s RUNNING
142                  lxc-info  -n $name                  lxc-info  -n $name
143                  echo $name > /var/lib/lxc/${name}/on_boot                  test -f /var/lib/lxc/${name}/on_boot || echo $name > /var/lib/lxc/${name}/on_boot
144          fi          fi
145  }  }
146    
147  lxc_watchdog() {  lxc_watchdog() {
148  name=$1  name=$1
149  rootfs=$(lxc_rootfs $1)  rootfs=$(lxc_rootfs $1)
150    run=$rootfs/var/run
151    test -L $run && run=$rootfs/`readlink $run` # recent Debian have symlink to /run
152    cd $run || echo "can't cd watchdog into $run"
153    
154  while true; do  while true; do
         vps_utmp=${rootfs}/var/run/utmp  
155          tasks=`wc -l < /cgroup/${name}/tasks`          tasks=`wc -l < /cgroup/${name}/tasks`
156            stop_on=1 # init
157            sulogins=`lxc-ps --name $name | grep sulogin | wc -l`
158            if [ "$sulogins" -gt 0 ] ; then
159                    stop_on=`expr $stop_on + $sulogins`
160            fi
161    
162          test -z "$tasks" && exit 1          test -z "$tasks" && exit 1
163          if [ "$tasks" -eq 1 ]; then          if [ "$tasks" -eq $stop_on ]; then
164    
165                  runlevel="$(runlevel ${vps_utmp})"                  runlevel="$(runlevel utmp)"
166                  echo `date +%Y-%m-%dT%H:%M:%S` "$name runlevel $runlevel"                  lxc_log "$name runlevel $runlevel"
167    
168                  case $runlevel in                  case $runlevel in
169                  N*)                  N*)
170                          # nothing for new boot state                          # nothing for new boot state
171                  ;;                  ;;
172                  ??0)                  ??0|unknown)
173                          echo "$name halt"                          lxc_log "$name halt"
174                          lxc-stop -n "${name}"                          lxc-stop -n "${name}"
175                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
176                          break                          break
177                  ;;                  ;;
178                  ??6)                  ??6)
179                          echo "$name reboot";                          lxc_log "$name reboot";
180                          lxc-stop -n ${name}                          lxc-stop -n ${name}
181                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
182                          lxc-start -d -n ${name} -o /tmp/${name}.log                          lxc-start -d -n ${name} -o /tmp/${name}.log
# Line 141  while true; do Line 188  while true; do
188                  ;;                  ;;
189                  esac                  esac
190          else          else
191                  echo "# $name $tasks tasks"                  lxc_log "$name $tasks tasks $sulogins console"
192          fi          fi
193    
194          # time of 5 minutes on it JUST IN CASE...          # time of 5 minutes on it JUST IN CASE...
195          inotifywait -qqt 300 ${vps_utmp}          inotifywait -qqt 300 utmp
196  done  done
197    
198  echo "${name} exited"  lxc_log "$name watchdog exited"
199    
200  }  }
201    
202    
203    usage() {
204            echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
205            exit 3
206    }
207    
208  command_on_lxc() {  command_on_lxc() {
209  command=$1  command=$1
210  shift  shift
# Line 164  case "$command" in Line 216  case "$command" in
216  start)  start)
217          lxc_exists $1          lxc_exists $1
218          cleanup_init_scripts $1          cleanup_init_scripts $1
219          setup_inittab $1 ::power      "p0::powerfail:/sbin/init 0"          setup_inittab $1 ":respawn:/sbin/getty.*tty1"   "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
220          setup_inittab $1 ::ctrlaltdel "p6::ctrlaltdel:/sbin/init 6"          setup_inittab $1 "::power"                      "p0::powerfail:/sbin/init 0"
221            setup_inittab $1 "::ctrlaltdel"                 "p6::ctrlaltdel:/sbin/init 6"
222          lxc_start $1          lxc_start $1
223          ( nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &          # give container 5 seconds to start more than one process
224            ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
225          ;;          ;;
226  stop|halt)  stop|halt)
227          lxc_exists $1          lxc_exists $1
# Line 179  reload|force-reload|restart|reboot) Line 233  reload|force-reload|restart|reboot)
233  watchdog)  watchdog)
234          lxc_watchdog $1          lxc_watchdog $1
235          ;;          ;;
236    boot)
237            echo $1 > /var/lib/lxc/$1/on_boot
238            ;;
239    disable)
240            echo -n > /var/lib/lxc/$1/on_boot
241            ;;
242  *)  *)
243          echo "Usage: $0 {start|stop|restart|status}" >&2          usage
         exit 3  
244          ;;          ;;
245    
246  esac  esac
# Line 189  esac Line 248  esac
248  }  }
249    
250  command=$1  command=$1
251  shift  test -z "$command" && usage
   
252  test "$command" = "status" && lxc_status && exit  test "$command" = "status" && lxc_status && exit
253    shift
254    
255  if [ -z "$1" ] ; then  if [ -z "$1" ] ; then
256          ls /var/lib/lxc/*/on_boot | while read path ; do          ls /var/lib/lxc/*/on_boot | while read path ; do
257                  name=`echo $path | cut -d/ -f5`                  name=`echo $path | cut -d/ -f5`
258                  command_on_lxc $command $name                  if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
259                            command_on_lxc $command $name
260                    else
261                            echo "# skip $command $name"
262                    fi
263          done          done
264  else  else
265          while [ ! -z "$1" ] ; do          while [ ! -z "$1" ] ; do

Legend:
Removed from v.184  
changed lines
  Added in v.272

  ViewVC Help
Powered by ViewVC 1.1.26